<?php

date_default_timezone_set('Europe/Paris');
$publicDir = $_SERVER['DOCUMENT_ROOT'];
$baseUri = '/';

require_once 'Sabre/autoload.php';

$root = new \Sabre\DAV\FS\Directory($publicDir);
$server = new \Sabre\DAV\Server($root);
if (isset($baseUri))
    $server->setBaseUri($baseUri);

$lockBackend = new \Sabre\DAV\Locks\Backend\File('/locksdb');
$lockPlugin = new \Sabre\DAV\Locks\Plugin($lockBackend);
$server->addPlugin($lockPlugin);

$browser = new \Sabre\DAV\Browser\Plugin();
$server->addPlugin($browser);

// Automatically guess (some) contenttypes, based on extesion
$server->addPlugin(new \Sabre\DAV\Browser\GuessContentType());

// Temporary file filter
//$tempFF = new \Sabre\DAV\TemporaryFileFilterPlugin($tmpDir);
//$server->addPlugin($tempFF);

$server->exec();
